<?php

//////////////////////////////////////////////////////////////
//===========================================================
// ostemplates_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       8th Mar 2010
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function getSortHeader($header_name, $sort_column, $sort_column_by, $column ,$size = 90){

	global $theme, $globals;
	
	$str = '<div class="d-inline-flex align-items-center" style="width:'.$size.'px;">
				<div class="mr-2">
					<span class="" >'.$header_name.'</span>
				</div>
				<span class="sorter">
					<a class="text-dark" href="'.$globals['index'].'act=ostemplates&sortcolumn='.$column.'&sortby=asc"><i class="fas fa-sort-up"></i></a><br>
					<a class="text-dark" href="'.$globals['index'].'act=ostemplates&sortcolumn='.$column.'&sortby=desc"><i class="fas fa-sort-down"></i></a>
				</span>
			</div>';
		
	return $str;
}

function ostemplates_theme(){

global $theme, $globals, $kernel, $user, $l, $oslist, $error, $installed, $done, $mgs, $servers, $sort_column, $sort_column_by, $ostemplates;

softheader($l['<title>']);

echo '
<div class="bg">
<div class="row my-3 mx-auto">
	<div class="col-10">
		<h4 class="text-dark"><i class="fas fa-compact-disc"></i> '.$l['tit_ostmp'].'</h4>
	</div>
		<div class="col-2 text-right">
		<span><a href="'.$globals['docs'].'os-templates/" target="_blank" tooltip="'.$l['wiki_help'].'"><i class="icon-help text-dark" ></i></a></span>
	</div>
</div>';

error_handle($error);

echo '<script language="javascript" type="text/javascript"><!-- // --><![CDATA[

function go_click(ele) {
	
	if($(ele).parent().prev().find("select").val() == 0){
		showalert("'.$l['no_action'].'","1");
		return false;
	}
	
	var os_list = new Array();
	
	$(".ios:checked").each(function() {
		os_list.push($(this).val());
	});
	
	if(os_list.length < 1){
		showalert("'.$l['nothing_selected'].'", "1");
		return false;
	}
	
	if($(ele).parent().prev().find("select").val() == 1){
		Delos(os_list);
	} else if($(ele).parent().prev().find("select").val() == 2){
		show_server_select(os_list);
	}
	
}

function Delos(os_list){
	
	showalert("'.$l['del_conf'].'" ,"3" ,function(confirm){
		if(confirm == false){
			return false;
		}else{
			var finalData = new Object();
			finalData["delete"] = os_list.join(",");

			//alert(finalData);
			//return false;
			
			$("#progress_bar").show();
			
			$.ajax({
				type: "POST",
				url: "'.$globals['index'].'act=ostemplates&api=json",
				data : finalData,
				dataType : "json",
				success: function(data){
					$("#progress_bar").hide();
					if("done" in data){
						setTimeout(function(){showalert("'.$l['action_completed'].'");
						$("#alert-modal").on("hidden.bs.modal", function (e) {
							location.reload(true);
						});} ,200);
					}
					if("error" in data){
						setTimeout(function(){showalert(data["error"],"1");} ,200);
					}
					
				},
				error: function(data) {
					$("#progress_bar").hide();
					//alert(data.description);
					return false;
				}
			});
		}
	});
	return false;
};

function serids_select_change() {
	var serids = $("#serids_select").val().join(",");
	$("#serids").val(serids);
}

function show_server_select(os_list) {';
	
	if(is_slave()) {
		echo 'showalert("'.$l['slave_cant_exp'].'","1");
		return false;';
	} else {
		
		echo 'var $modal_form = $(\'<form id="sync_os_form" action="" method="post"> \
			<input type="hidden" id="sync_os" name="sync_os" /> \
			<input type="hidden" id="serids" name="serids" /> \
			<br> \
			<div class="row"> \
				<div class="col-sm-6"> \
				<label class="control-label">'.$l['select_servers'].'&nbsp;<a class="info" data-placement="right" tooltip="'.$l['select_servers_exp'].'"><i class="fas text-primary fa-info-circle"></i></a></label> \
				</div> \
				<div class="col-sm-6"> \
					<select class="form-control" id="serids_select" onchange="serids_select_change();" multiple> \ ';
						
						foreach($servers as $serid => $server) {
							if(empty($serid)) continue;
							echo '<option value="'.$serid.'">'.$server['server_name'].' - '.$server['ip'].'</option> \ ';
						}
						
					echo '</select> \
				</div> \
			</div> \
			<br> \
			<div class="row"> \
				<div class="col-sm-6"> \
					<label class="control-label">'.$l['force_sync'].'&nbsp;<a class="info" data-placement="right" tooltip="'.$l['force_sync_exp'].'"><i class="fas text-primary fa-info-circle"></i></a></label> \
				</div> \
				<div class="col-sm-6"> \
					<div class="custom-control custom-checkbox"> \
						<input type="checkbox" class="ios custom-control-input" id="force_sync" name="force_sync"> \
						<label class="custom-control-label" for="force_sync"></label> \
					</div> \
				</div> \
			</div> \
			<br> \
			<div class="row"> \
				<div class="col-sm-12 text-center"> \
					<input class="go_btn" value="'.$l['sync_os'].'" type="submit"> \
				</div> \
			</div>\
		</form>\');
		
		// Show dialog for server select
		$modal_form.find("#sync_os").val(os_list.join(","));
		$("#common_modal .fhead").text("'.$l['sync_os'].'");
		$("#common_modal_body").html($modal_form);
		$("#common_modal").modal("show");
		show_tooltip();';
		
	}
	
echo '}

// ]]></script>

';

if($done == 'sync_os'){
	echo '<div class="notice"><b>NOTE : </b>&nbsp; '.$l['done_sync_os'].'</div>';
} elseif(!empty($done)) {
	show_alert($l['done']);
}

if(empty($oslist)){
	show_alert($l['no_os'], "2");
	echo '<div class="notice"><b>NOTE : </b>&nbsp; '.$l['no_os'].'</div>';
}else{
echo'<div class="row mx-auto w-100 mt-3">
	<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
		page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
	echo'
	</div>
	<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3">
		<div class="bottom-menu float-right w-100">
			<div class="row my-auto">
				<div class="p-0">
					<label>'.$l['with_selected'].'</label>
				</div>
				<div class="col p-0">
					<select class="custom-select" name="os_task_select" id="os_task_select">
						<option value="0">---</option>
						<option value="1">'.$l['ms_delete'].'</option>
						<option value="2">'.$l['ms_sync_os'].'</option>
					</select>
				</div>
				<div class="pl-2">
					<input type="submit" id ="ostemplate_submit" class="go_btn" name="ostemplate_submit" value="'.$l['go'].'" onclick="go_click(this); return false;">
				</div>
			</div>
		</div>
	</div>
</div>
<form accept-charset="'.$globals['charset'].'" name="multi_os" id="multi_os" method="post" action="" class="form-horizontal">
<div class="w-100 mx-auto sticky">
<table class="table table-hover tablesorter">
<tr>
<th class="min_width" align="center">'.getSortHeader($l['osid'], $sort_column, $sort_column_by, 'osid' ,30).'</th>
<th align="center">'.$l['head_os'].'</th>
<th align="center">'.$l['head_type'].'</th>
<th align="center">'.getSortHeader($l['head_os_name'], $sort_column, $sort_column_by, 'name').'</th>
<th align="center">'.$l['head_name'].'</th>
<th align="center">'.$l['head_mg'].'</th>
<th align="center">'.getSortHeader($l['head_size'], $sort_column, $sort_column_by, 'size').'</th>
<th align="center">'.$l['head_ondisksize'].'</th>
<th align="center">'.$l['head_usedby'].'</th>
<th colspan="3" class="min_width">'.$l['manage'].'</th>
<th align="center" class="z-index-1 min_width">
	'.get_checkbox('select_all', '', 'select_all', array('chk_it' => 0), '', 'select_all').'
</th>
</tr>';
//r_print($oslist);

$i = 1;
foreach ($ostemplates as $k => $v) {
	echo'<tr>
		<td align="left">'.$k.'</td>
		<td align="center"><img src="'.distro_logo($v['distro']).'" width="35px"/></td>
		<td align="center"><img width="35px" src="'.$theme['images'].'admin/'.$v['type'].(!empty($v['hvm']) ? 'hvm' : '').'_42.gif" /></td>
		<td align="left">'.$v['name'].'</td>
		<td '.(empty($v['filename']) ? 'align="center">-</td>' : "align='left'>{$v['filename']}</td>").'
		<td align="left">';

		$tmp = array();
					
		if(empty($v['mg'])){
			echo '<em>'.$l['none'].'</em>';
		}else{
			foreach($v['mg'] as $mk){
				$tmp[] = $mgs[$mk]['mg_name'];
			}
			echo implode(', ', $tmp);				
		}
					
		echo '</td>
		<td align="center">'.round($v['size']/1024/1024).' MB</td>
		<td align="center">'.round(vfilesize($globals[$v['type'].'os'].'/'.$v['filename'])/1024/1024).' MB</td>
		<td align="center">'.(empty($installed[$k]) ? 0 : $installed[$k]).'</td>
		<td align="center" width="20"><a href="javascript:void(0);" title="'.$l['sync_os'].'" onclick="show_server_select(['.$k.']); return false"><i class="fas fa-sync-alt h6 m-0 text-info"></i></a></td>
		<td align="center" width="20"><a href="'.$globals['ind'].'act=edittemplate&osid='.$k.'"  title="'.$l['edit_os'].'"><i class="fas fa-edit text-warning"></i></a></td>
		<td align="center" width="20"><a href="javascript:void(0);" onclick="return Delos(['.$k.']);"  title="'.$l['del_os'].'"><i class="fas fa-trash text-danger"></i></a></td>
		<td width="20" valign="middle" align="center">
			'.get_checkbox('ostemplate_list[]', '', '', array('chk_it' => 0), $k).'
		</td>
	</tr>';
	$i++;
}
echo '</table>
</div>';
echo'<div class="row mx-auto w-100 mt-3">
	<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
		page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
	echo'
	</div>
	<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3">
		<div class="bottom-menu float-right w-100">
            <div class="row my-auto">
                <div class="p-0">
                    <label>'.$l['with_selected'].'</label>
                </div>
                <div class="col p-0">
					<select class="custom-select" name="os_task_select" id="os_task_select">
						<option value="0">---</option>
						<option value="1">'.$l['ms_delete'].'</option>
						<option value="2">'.$l['ms_sync_os'].'</option>
					</select>
                </div>
                <div class="pl-2">
					<input type="submit" id ="ostemplate_submit" class="go_btn" name="ostemplate_submit" value="'.$l['go'].'" onclick="go_click(this); return false;">
                </div>
            </div>
		</div>
	</div>
</div>
</form>

<div id="progress_bar" style="display:none;">
	<br />
	<center>
		<font id="progress_txt" size="4" color="#222222">'.$l['action_msg'].'</font>
	</center>
	<div class="my-2" align="center">
		<div class="progress w-50">
			<div class="progress-bar bg-primary progress-bar-striped progress-bar-animated w-100">
			</div>
		</div>
	</div>
	<center>
		'.$l['notify_msg'].'
	</center>
</div>';

}

echo '<center><div class="col-sm-11"><a href="'.$globals['ind'].'act=addtemplate" title="'.$l['add_temp'].'" class="link_btn">'.$l['add_temp'].'</a> &nbsp;
<a href="'.$globals['ind'].'act=os" title="'.$l['temp_brwose'].'" class="link_btn">'.$l['temp_brwose'].'</a></div></center><br/>
</div>';
softfooter();

}

?>