<?php

//////////////////////////////////////////////////////////////
//===========================================================
// rdns_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       8th Mar 2010
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function rdns_theme(){

global $theme, $globals, $kernel, $user, $l, $cluster, $error, $servers, $done, $ips, $pdns, $pdnsid;

softheader($l['<title>']);

echo '
<div class="bg">
<div class="row my-3 mx-auto">
	<div class="col-10">
		<h4 class="text-dark"><i class="fas fa-passport"></i> '.$l['add_rdns'].'</h4>
	</div>
	<div class="col-2 text-right">
		<span><a href="'.$globals['docs'].'configure-reverse-dns/" target="_blank" tooltip="'.$l['wiki_help'].'"><i class="icon-help text-dark" ></i></a></span>
	</div>
</div>';

error_handle($error);

if(!empty($done)){
	show_alert($l['done']);
}

echo '<div id="form-container">
<form accept-charset="'.$globals['charset'].'" name="rdns" method="post" action="" class="form-horizontal">

<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['zone_name'].'&nbsp;<a class="info" data-placement="right" tooltip="'.$l['exp_zone_name'].'" id="zone_tooltip"><i class="fas text-primary fa-info-circle"></i></a></label><br>
	</div>
	<div class="col-sm-4">
	
		<input type="text" class="form-control" name="zone_name" value="'.POSTval('zone_name', '').'" size="30">
	</div>
</div>
<br>
<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['ns'].' 1</label><br />
	</div>
	<div class="col-sm-4">
		<input type="text" class="form-control" name="ns1" value="'.POSTval('ns1', '').'" size="30">
	</div>
</div>
<br/>
<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['ns'].' 2</label><br />
	</div>
	<div class="col-sm-4">
		<input type="text" class="form-control" name="ns2" value="'.POSTval('ns2', '').'" size="30">
	</div>
</div>
<br/>
<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['ns'].' 3</label><br />
	</div>
	<div class="col-sm-4">
		<input type="text" class="form-control" name="ns3" value="'.POSTval('ns3', '').'" size="30">
	</div>
</div>
<br/>
<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['ns'].' 4</label><br />
	</div>
	<div class="col-sm-4">
		<input type="text" class="form-control" name="ns4" value="'.POSTval('ns4', '').'" size="30">
	</div>
</div>
<br/>
<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['hostmasteremail'].'&nbsp;<a class="info" data-placement="right" tooltip="'.$l['exp_hostmasteremail'].'"><i class="fas text-primary fa-info-circle"></i></a></label><br>
	</div>
	<div class="col-sm-4">
	
		<input type="text" class="form-control" name="hostmasteremail" value="'.POSTval('hostmasteremail', '').'" size="30">
	</div>
</div>
<br>
<div class="row mx-auto w-100">
	<div class="col-sm-4"><label class="control-label">'.$l['pdns_server'].'&nbsp;<a class="info" data-placement="right" tooltip="'.$l['exp_pdns_server'].'"><i class="fas text-primary fa-info-circle"></i></a></label><br>
	</div>
	<div class="col-sm-4 server-select-lg">
	
		<select class="custom-control virt-select" name="pdnsid">';
	foreach($pdns as $k => $v){
		echo '<option value="'.$v['id'].'" '.ex_POSTselect('pdnsid', $pdnsid).' >'.$v['name'].'</option>';
	}
echo '</select>
	</div>
</div>

</div>
<br /><br />
<center><input type="submit" value="'.$l['sub_but'].'" class="go_btn" name="rdns"/></center>

</form>
</div>
';

softfooter();

}

?>